<!doctype html>
<html class="not-ready lg:text-base" lang="en">
  <head>
  <meta charset="utf-8" />
  <meta http-equiv="X-UA-Compatible" content="IE=edge" />
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no" />

  <!-- Title -->
  <title>
    mini-project6 - Home
  </title>

  <!-- Meta -->
  <meta name="theme-color" />

  <!-- Author -->
  
  <meta name="description" content="mini-project6" />
  <meta name="author" content="mini-project6" />
  

  <!-- CSS & JS -->
  <link rel="preload stylesheet" as="style" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/main.css" />
  <style>
    :root {
      --bg: #f4f4f5;
      --bg-dark: #18181b;
      --header: #e4e4e7;
      --header-dark: #27272a;
    }
  </style>

  

  <!-- Dark Icon -->
  <link rel="preload" as="image" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/icons/theme.svg" />

  <!-- Math -->
  
  <!---->

  <!-- Mermaid -->
  
  <!---->

  <!-- Favicon -->
  <link rel="icon" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/favicon.ico" />
  <link rel="apple-touch-icon" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/apple-touch-icon.png" />

  <!-- Feeds -->
  
  <!---->
  
  <link
    rel="alternate"
    type="application/atom+xml"
    title="Atom"
    href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/atom.xml"
  />
  
  <!---->
  

  <!-- Canonical -->
  <link rel="canonical" href="https:&#x2F;&#x2F;individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io&#x2F;projects&#x2F;project6&#x2F;" />
</head>

  <body class="text-black duration-200 ease-out dark:text-white">
    <header
  class="header fixed top-0 z-40 mx-auto min-h-[3.5rem] w-full"
>
  <div class="mx-auto w-full max-w-4xl p-3 lg:flex lg:justify-between">
    <div class="flex justify-between">
      <div class="flex items-center">
        <a class="text-2xl font-semibold" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io">Home</a>
        <div
          class="btn-dark ml-4 h-6 w-6 shrink-0 cursor-pointer text-[0] [background:url(./icons/theme.svg)_left_center/cover_no-repeat] dark:invert dark:[background-position:right]"
          role="button"
          aria-label="Dark"
        ></div>
      </div>
      
      <div
        class="btn-menu relative z-50 flex h-8 w-8 shrink-0 cursor-pointer flex-col items-center justify-center gap-2.5 lg:hidden"
        role="button"
        aria-label="Menu"
      ></div>
      
    </div>
    <script>
      // base
      const htmlClass = document.documentElement.classList;
      setTimeout(() => {
        htmlClass.remove("not-ready");
      }, 10);

      // mobile menu
      const btnMenu = document.querySelector(".btn-menu");
      btnMenu?.addEventListener("click", () => {
        htmlClass.toggle("open");
      });

      // dark theme
      const setDark = (isDark) => {
        htmlClass[isDark ? "add" : "remove"]("dark");
        localStorage.setItem("dark", isDark);
      };

      // init
      const darkScheme = window.matchMedia("(prefers-color-scheme: dark)");
      if (htmlClass.contains("dark")) {
        setDark(true);
      } else {
        const darkVal = localStorage.getItem("dark");
        setDark(darkVal ? darkVal === "true" : darkScheme.matches);
      }

      // listen system
      darkScheme.addEventListener("change", (event) => {
        setDark(event.matches);
      });

      // manual switch
      const btnDark = document.querySelector(".btn-dark");
      btnDark.addEventListener("click", () => {
        setDark(localStorage.getItem("dark") !== "true");
      });
    </script>
    
    <nav class="flex w-full items-center lg:w-auto">
      <ul
        class="nav-wrapper flex w-full flex-col py-2 lg:w-auto lg:flex-row lg:self-center lg:py-0"
      >
        
        <li>
          <a
            class="primary-link block py-2 text-center text-lg font-medium lg:px-3 lg:py-0"
            href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/projects"
            >Projects</a
          >
        </li>
        
        <li>
          <a
            class="primary-link block py-2 text-center text-lg font-medium lg:px-3 lg:py-0"
            href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/About"
            >About</a
          >
        </li>
        
      </ul>
    </nav>
    
  </div>
</header>


    <main
      class="prose prose-neutral relative mx-auto min-h-[calc(100%-9rem)] max-w-3xl px-4 pb-16 pt-32 dark:prose-invert"
    >
      
<article>
  <header class="mb-16">
    <h1 class="!my-0 pb-2.5">mini-project6</h1>
    <div class="text-sm antialiased opacity-60">
  
  <time>2024-03-08</time>
  <span class="mx-1">&middot;</span>
  <span>3min</span>
  <!---->
  
  <!---->
  
  <span class="mx-1">&middot;</span>
  <span>yanbo</span>
  
</div>

  </header>

  

  <!-- TOC -->
  <!---->
<div class="block-bg mb-12 flex rounded-lg p-2 text-lg">
  <details>
    <summary class="cursor-pointer py-1 pl-4">
      <span>Table of Contents</span>
    </summary>
    <div class="px-2">
      <ul>
        
        <li>
          <a class="no-underline hover:underline" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/projects/project6/#yg229-mini-project-6"
            >yg229_mini_project_6</a
          >
          
          <ul>
            
            <li>
              <a class="no-underline hover:underline" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/projects/project6/#author"
                >Author</a
              >
            </li>
            
            <li>
              <a class="no-underline hover:underline" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io/projects/project6/#configuration-and-initialization"
                >Configuration and Initialization:</a
              >
            </li>
            
          </ul>
          
        </li>
        
      </ul>
    </div>
  </details>
</div>

<!---->

  <!-- Content -->
  <section><ul>
<li>Link to mini-project 6: <a href="https://gitlab.com/dukeaiml/IDS721/mini-project6-yg229.git">GitLab repo</a></li>
</ul>
<h1 id="yg229-mini-project-6">yg229_mini_project_6</h1>
<p>In this project, I implemented a AWS Lambda function that designed to increment and report the number of times a website (or a specific page) has been accessed. It uses AWS DynamoDB for storage, it uses AWS Lambda with the lambda_http crate to handle web requests and MySQL for database interactions. The logging functionality within the Lambda is set up using the tracing and tracing-subscriber crates. The modification is based on the week5's mini project.</p>
<h2 id="author">Author</h2>
<p>Yanbo Guan yg229</p>
<h2 id="configuration-and-initialization">Configuration and Initialization:</h2>
<ol>
<li>In cargo,toml, add the following dependecies:</li>
</ol>
<pre data-lang="features" style="background-color:#2b303b;color:#c0c5ce;" class="language-features "><code class="language-features" data-lang="features"><span>tracing-subscriber = { version = &quot;0.3&quot;, default-features = false, features = [&quot;env-filter&quot;, &quot;fmt&quot;] }``` 
</span><span>2. Go to Monitoring and Configuration Tools -&gt; Enable: X-Ray active tracing, Enable: Lambda Insights enhanced monitoring
</span><span>3. Here is the screenshot after configuration.
</span><span>![](1.png)
</span><span>
</span><span>## Lambda function summary
</span><span>1. Dependencies and Setup: The code imports necessary crates for DynamoDB interaction (aws_sdk_dynamodb), AWS configuration loading (aws_config), Lambda function runtime (lambda_runtime), JSON handling (serde_json), and data serialization (serde).
</span><span>
</span><span>2. Main Function: The main async function sets up the Lambda function using lambda_runtime::run with a handler function named lambda_handler.
</span><span>
</span><span>3. Lambda Handler Function: lambda_handler is an asynchronous function that gets triggered upon Lambda invocations. It doesn&#39;t use the event data (LambdaEvent&lt;Value&gt;) directly but proceeds to increment and retrieve the count of website accesses.
</span><span>
</span><span>4. Increment and Get Count Function: increment_and_get_count asynchronously communicates with a DynamoDB table named testdb. It updates an item identified by the key yg229 with the value site_access_count. The function increments an access_count attribute for this item, ensuring the count starts at 0 if it does not exist. It then retrieves and returns the new count as an integer.
</span><span>
</span><span>5. DynamoDB Interaction: The DynamoDB client is configured with environment settings and is used to perform an update_item operation. This operation uses an update_expression to increment access_count or initialize it to 0 if it&#39;s not present. It specifies returning the updated values, from which the access_count attribute&#39;s new value is extracted and returned.
</span><span>
</span><span>6. Response Construction: The Lambda function responds with a message indicating the total number of viewers, incorporating the dynamically updated count from DynamoDB.
</span><span>
</span><span>## Deploy
</span><span>1. ```cargo lambda build --release```
</span><span>2. ```cargo lambda deploy```
</span><span>![](2.png)
</span><span>3. Add permissions for the role created (Aminastrator access if needed)
</span><span>3. Add API Gateway
</span><span>![](3.png)
</span><span>
</span><span>## Results
</span><span>To test the functionality of logging, go to CloudWatch.
</span><span>Here are screenshots demonstrate the logging functions:
</span><span>![](4.png)</span></code></pre>
</section>

  <hr />

  <!-- Post Taxonomies -->
  
<!---->

  <!-- Post Nav -->
  
<nav class="block-bg mt-12 flex rounded-lg text-lg">
  
  <a
    class="block-hover-mask flex w-1/2 items-center rounded-l-md p-6 pr-3 font-semibold no-underline"
    href="https:&#x2F;&#x2F;individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io&#x2F;projects&#x2F;project5&#x2F;"
    ><span class="mr-1.5">←</span><span>mini-project5</span></a
  >
  <!---->
  
</nav>

<!---->

  <!-- Comment -->
  
</article>

    </main>

    <footer class="mx-auto flex max-w-3xl flex-wrap items-center px-8 py-4 text-sm opacity-60">
  <div class="mr-auto basis-full lg:basis-1/2">
    &copy; 2020 -  2024
    <a class="link" href="https://individual-project1-dukeaiml-ids721-3a874b9b83d2e9da13fe30042b7.gitlab.io"
      >yanbo</a
    >
     |<!---->
    <!---->
    <a class="link" href="https:&#x2F;&#x2F;creativecommons.org&#x2F;licenses&#x2F;by-sa&#x2F;4.0&#x2F;deed" rel="noopener" target="_blank">
      CC BY-SA 4.0
    </a>
    <!---->
    
  </div>
  <div class="flex basis-full lg:basis-1/2 lg:justify-end">
    <a class="link mr-6 lg:ml-6" href="https://www.getzola.org/" rel="noopener" target="_blank"
      >Powered by Zola</a
    >
    <a class="link" href="https://github.com/st1020/kita" rel="noopener" target="_blank">✎ Kita</a>
  </div>
</footer>

  </body>
</html>
